----------------------------------------------------------------------------------
-- Company: Univ Lyon, UJM-Saint-Etienne, CNRS, Laboratoire Hubert Curien UMR 5516, F-42023, SAINT-ETIENNE, France
-- Creator: Cédric Marchand 
-- 
-- Create Date:    10:13:43 11/17/2015 
-- Design Name: 
-- Module Name:    mix_nibled - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mix_nibled is
  port(
    word_i  : in std_logic_vector(15 downto 0);
    nible_o : out std_logic_vector(3 downto 0)
  );
end mix_nibled;

architecture Behavioral of mix_nibled is

  COMPONENT x2
	PORT(
		nible_i : IN std_logic_vector(3 downto 0);          
		nible_o : OUT std_logic_vector(3 downto 0)
		);
	END COMPONENT;
  
  COMPONENT x4
	PORT(
		nible_i : IN std_logic_vector(3 downto 0);          
		nible_o : OUT std_logic_vector(3 downto 0)
		);
	END COMPONENT;
  
  signal x41_i : std_logic_vector(3 downto 0);
  signal x42_i : std_logic_vector(3 downto 0);
  signal x41_o : std_logic_vector(3 downto 0);
  signal x42_o : std_logic_vector(3 downto 0);
  signal x21_o : std_logic_vector(3 downto 0);
  signal x22_o : std_logic_vector(3 downto 0);


begin

  x41_i <= word_i(3 downto 0) xor word_i(15 downto 12);
  Inst_x41 : x4 PORT MAP(
		nible_i => x41_i,
		nible_o => x41_o
	);
  
  Inst_x21: x2 PORT MAP(
		nible_i => x41_o,
		nible_o => x21_o
	);
  
  x42_i <= word_i(7 downto 4) xor word_i(11 downto 8);
  Inst_x42 : x4 PORT MAP(
		nible_i => x42_i,
		nible_o => x42_o
	);
  
  Inst_x22: x2 PORT MAP(
		nible_i => x42_o,
		nible_o => x22_o
	);
  
  nible_o <= x21_o xor x41_o xor x41_i xor x22_o xor x42_i;

end Behavioral;

