----------------------------------------------------------------------------------
-- Company: Univ Lyon, UJM-Saint-Etienne, CNRS, Laboratoire Hubert Curien UMR 5516, F-42023, SAINT-ETIENNE, France
-- Creator: Cédric Marchand 
-- 
-- Create Date:    10:59:34 11/12/2015 
-- Design Name: 
-- Module Name:    mix_row - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mix_row is
  port(
    state_i : in std_logic_vector(63 downto 0);
    state_o : out std_logic_vector(63 downto 0)
  );
end mix_row;

architecture Behavioral of mix_row is

  COMPONENT x2
	PORT(
		nible_i : IN std_logic_vector(3 downto 0);          
		nible_o : OUT std_logic_vector(3 downto 0)
		);
	END COMPONENT;
  
  COMPONENT x4
	PORT(
		nible_i : IN std_logic_vector(3 downto 0);          
		nible_o : OUT std_logic_vector(3 downto 0)
		);
	END COMPONENT;
  
  signal x41_o : std_logic_vector(3 downto 0);
  signal x42_o : std_logic_vector(3 downto 0);
  signal x43_o : std_logic_vector(3 downto 0);
  signal x44_o : std_logic_vector(3 downto 0);
  signal x21_o : std_logic_vector(3 downto 0);
  signal x22_o : std_logic_vector(3 downto 0);
  signal x23_o : std_logic_vector(3 downto 0);
  signal x24_o : std_logic_vector(3 downto 0);
  signal x25_o : std_logic_vector(3 downto 0);
  signal x26_o : std_logic_vector(3 downto 0);
  signal x27_o : std_logic_vector(3 downto 0);
  signal x28_o : std_logic_vector(3 downto 0);

begin
  
  state_o(47 downto 0) <= state_i(63 downto 16);
  
  Inst_x41: x4 PORT MAP(
		nible_i => state_i(3 downto 0),
		nible_o => x41_o
	);
  
  Inst_x42: x4 PORT MAP(
		nible_i => state_i(7 downto 4),
		nible_o => x42_o
	);
  
  Inst_x43: x4 PORT MAP(
		nible_i => state_i(11 downto 8),
		nible_o => x43_o
	);
  
  Inst_x44: x4 PORT MAP(
		nible_i => state_i(15 downto 12),
		nible_o => x44_o
	);
  
  Inst_x21: x2 PORT MAP(
		nible_i => state_i(35 downto 32),
		nible_o => x21_o
	);
  
  Inst_x22: x2 PORT MAP(
		nible_i => state_i(39 downto 36),
		nible_o => x22_o
	);
  
  Inst_x23: x2 PORT MAP(
		nible_i => state_i(43 downto 40),
		nible_o => x23_o
	);
  
  Inst_x24: x2 PORT MAP(
		nible_i => state_i(47 downto 44),
		nible_o => x24_o
	);
  
  Inst_x25: x2 PORT MAP(
		nible_i => state_i(51 downto 48),
		nible_o => x25_o
	);
  
  Inst_x26: x2 PORT MAP(
		nible_i => state_i(55 downto 52),
		nible_o => x26_o
	);
  
  Inst_x27: x2 PORT MAP(
		nible_i => state_i(59 downto 56),
		nible_o => x27_o
	);
  
  Inst_x28: x2 PORT MAP(
		nible_i => state_i(63 downto 60),
		nible_o => x28_o
	);
  
  state_o(63 downto 60) <= x44_o xor state_i(31 downto 28) xor x24_o xor x28_o;
  state_o(59 downto 56) <= x43_o xor state_i(27 downto 24) xor x23_o xor x27_o;
  state_o(55 downto 52) <= x42_o xor state_i(23 downto 20) xor x22_o xor x26_o;
  state_o(51 downto 48) <= x41_o xor state_i(19 downto 16) xor x21_o xor x25_o;

end Behavioral;

