----------------------------------------------------------------------------------
-- Company: Univ Lyon, UJM-Saint-Etienne, CNRS, Laboratoire Hubert Curien UMR 5516, F-42023, SAINT-ETIENNE, France
-- Creator: Cédric Marchand 
-- 
-- Create Date:    10:37:15 11/12/2015 
-- Design Name: 
-- Module Name:    sbox - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity sbox is
    Port( 
      sbox_i : in  STD_LOGIC_VECTOR (3 downto 0);
      sbox_o : out  STD_LOGIC_VECTOR (3 downto 0)
    );
end sbox;

architecture Behavioral of sbox is
begin

  with sbox_i select
    sbox_o <=
      x"c" when x"0",
      x"5" when x"1",
      x"6" when x"2",
      x"b" when x"3",
      x"9" when x"4",
      x"0" when x"5",
      x"a" when x"6",
      x"d" when x"7",
      x"3" when x"8",
      x"e" when x"9",
      x"f" when x"a",
      x"8" when x"b",
      x"4" when x"c",
      x"7" when x"d",
      x"1" when x"e",
      x"2" when others;

end Behavioral;

