----------------------------------------------------------------------------------
-- Company: Univ Lyon, UJM-Saint-Etienne, CNRS, Laboratoire Hubert Curien UMR 5516, F-42023, SAINT-ETIENNE, France
-- Creator: Cédric Marchand 
-- 
-- Create Date:    10:51:51 11/12/2015 
-- Design Name: 
-- Module Name:    sbox_d - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity sbox_d is
    Port( 
      sbox_i : in  STD_LOGIC_VECTOR (3 downto 0);
      sbox_o : out  STD_LOGIC_VECTOR (3 downto 0)
    );
end sbox_d;

architecture Behavioral of sbox_d is

begin

  with sbox_i select
    sbox_o <= 
      x"5" when x"0",
      x"e" when x"1",
      x"f" when x"2",
      x"8" when x"3",
      x"c" when x"4",
      x"1" when x"5",
      x"2" when x"6",
      x"d" when x"7",
      x"b" when x"8",
      x"4" when x"9",
      x"6" when x"a",
      x"3" when x"b",
      x"0" when x"c",
      x"7" when x"d",
      x"9" when x"e",
      x"a" when others;

end Behavioral;

